## jeolib-jiplib 1.1.5%2Bds

=== debian/changelog ===
jeolib-jiplib (1.1.5+ds-1) unstable; urgency=medium

  * Initial release.
    (closes: #1100830)
  * Added a patch to fix problems with Swig 4.3 currently used in sid (and
    retaining back-compatibility).

 -- Francesco Paolo Lovergine <frankie@debian.org>  Sun, 30 Mar 2025 18:23:40 +0200
