=== debian/changelog ===
jeolib-jiplib (1.1.5+ds-1build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:10:40 +0200

jeolib-jiplib (1.1.5+ds-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:00:15 +0200
