=== debian/control ===
Source: jeolib-jiplib
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>
Section: libs
Priority: optional
Build-Depends: chrpath,
               cmake,
               debhelper-compat (= 13),
               dh-python,
               dh-sequence-python3,
               dh-sequence-numpy3,
               libboost-filesystem-dev,
               libboost-serialization-dev,
               libfann-dev,
               libgdal-dev,
               libgsl-dev,
               libjsoncpp-dev,
               libmiallib-dev,
               pkgconf,
               python3,
               python3-all-dev,
               python3-numpy,
               python3-numpy-dev,
               python3-pip,
               python3-setuptools,
               swig
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debiani-gis/jeolib-jiplib
Vcs-Git: https://salsa.debian.org/debian-gis/jeolib-jiplib.git
Homepage: https://github.com/ec-jrc/jeolib-jiplib
Rules-Requires-Root: no

Package: libjiplib-dev
Section: libdevel
Architecture: any
Depends: libjiplib1 (= ${binary:Version}),
         ${misc:Depends}
Recommends: pkgconf
Description: ISPRA JRC image processing for geospatial data library - Development files
 This is an intermediate level library written in C++ with Python
 binding used by PyJeo and possibly other tools for processing geospatial images. It
 provides a a comprehensive set of image processing functionality including:
 .
  * Image classification
  * Feature extraction
  * Spatial filtering
  * Morphological operations
  * Support Vector Machine operations
  * Neural Network algorithms
 .
 This package contains headers, static objects, scripts used
 to develop a program that uses this library.

Package: libjiplib1
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ISPRA JRC image processing for geospatial data library
 This is an intermediate level library written in C++ with Python
 binding used by PyJeo and possibly other tools for processing geospatial images. It
 provides a a comprehensive set of image processing functionality including:
 .
  * Image classification
  * Feature extraction
  * Spatial filtering
  * Morphological operations
  * Support Vector Machine operations
  * Neural Network algorithms
 .
 This package contains the shared library.

Package: python3-jiplib
Architecture: any
Section: python
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Description: Python binding to the ISPRA JRC image processing for geospatial data library
 This is an intermediate level library written in C++ with Python
 binding used by PyJeo and possibly other tools for processing geospatial images. It
 provides a a comprehensive set of image processing functionality including:
 .
  * Image classification
  * Feature extraction
  * Spatial filtering
  * Morphological operations
  * Support Vector Machine operations
  * Neural Network algorithms
 .
 This package contains the Python classes and bindings.
