## jeolib-jiplib 1.1.6%2Bds

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
filenamemangle=s/(?:.*\/)?(?:rel|v|jeolib-jiplib)[\-\_]?(\d[\d\-\.]*)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/jeolib-jiplib-$1.$2/,\
repacksuffix=+ds \
https://github.com/ec-jrc/jeolib-jiplib/tags \
(?:.*?/archive/(?:.*?/)?)?(?:rel|v|jeolib-jiplib)[\-\_]?(\d[\d\-\.]+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
