## jeolib-jiplib 1.1.6+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,7 @@
 
 SET(JIPLIB_VERSION_MAJOR 1)
 SET(JIPLIB_VERSION_MINOR 1)
-SET(JIPLIB_VERSION_PATCH 5)
+SET(JIPLIB_VERSION_PATCH 6)
 SET(JIPLIB_VERSION "${JIPLIB_VERSION_MAJOR}.${JIPLIB_VERSION_MINOR}.${JIPLIB_VERSION_PATCH}")
 SET(PACKAGE_VERSION "${JIPLIB_VERSION}")
 SET(JIPLIB_SOVERSION "${JIPLIB_VERSION_MAJOR}")
