=== debian/changelog ===
jeolib-jiplib (1.1.6+ds-2build1) resolute; urgency=medium

  * Rebuild against latest gdal

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 02 Nov 2025 11:30:25 -0500

jeolib-jiplib (1.1.6+ds-2) unstable; urgency=medium

  * Team upload.
  * Ignore test failures everywhere except amd64.
  * Re-enable Salsa CI i386 jobs.
  * Use test-build-validate-cleanup instead of test-build-twice.
  * Add patch to fix library installation path.
  * Add patch to fix wheel build (requires --no-build-isolation)
  * Use cmake buildsystem for parallel builds.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 26 Oct 2025 08:03:45 +0100

jeolib-jiplib (1.1.6+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Add patch to fix FTBFS with GDAL 3.12.0.
    (closes: #1118729)
  * Update copyright file.
  * Drop obsolete include from rules file.
  * Drop patches applied upstream. Refresh remaining patches.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 25 Oct 2025 10:11:44 +0200
