=== debian/control ===
--- 
+++ 
@@ -28,7 +28,6 @@
 Vcs-Browser: https://salsa.debian.org/debiani-gis/jeolib-jiplib
 Vcs-Git: https://salsa.debian.org/debian-gis/jeolib-jiplib.git
 Homepage: https://github.com/ec-jrc/jeolib-jiplib
-Rules-Requires-Root: no
 
 Package: libjiplib-dev
 Section: libdevel
@@ -37,9 +36,9 @@
          ${misc:Depends}
 Recommends: pkgconf
 Description: ISPRA JRC image processing for geospatial data library - Development files
- This is an intermediate level library written in C++ with Python
- binding used by PyJeo and possibly other tools for processing geospatial images. It
- provides a a comprehensive set of image processing functionality including:
+ This is an intermediate level library written in C++ with Python binding used
+ by PyJeo and possibly other tools for processing geospatial images. It
+ provides a comprehensive set of image processing functionality including:
  .
   * Image classification
   * Feature extraction
@@ -48,17 +47,17 @@
   * Support Vector Machine operations
   * Neural Network algorithms
  .
- This package contains headers, static objects, scripts used
- to develop a program that uses this library.
+ This package contains headers, static objects, scripts used to develop a
+ program that uses this library.
 
 Package: libjiplib1
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: ISPRA JRC image processing for geospatial data library
- This is an intermediate level library written in C++ with Python
- binding used by PyJeo and possibly other tools for processing geospatial images. It
- provides a a comprehensive set of image processing functionality including:
+ This is an intermediate level library written in C++ with Python binding used
+ by PyJeo and possibly other tools for processing geospatial images. It
+ provides a comprehensive set of image processing functionality including:
  .
   * Image classification
   * Feature extraction
@@ -76,9 +75,9 @@
          ${shlibs:Depends},
          ${misc:Depends}
 Description: Python binding to the ISPRA JRC image processing for geospatial data library
- This is an intermediate level library written in C++ with Python
- binding used by PyJeo and possibly other tools for processing geospatial images. It
- provides a a comprehensive set of image processing functionality including:
+ This is an intermediate level library written in C++ with Python binding used
+ by PyJeo and possibly other tools for processing geospatial images. It
+ provides a comprehensive set of image processing functionality including:
  .
   * Image classification
   * Feature extraction
