=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export DEB_PYTHON_INSTALL_LAYOUT=deb_system

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --buildsystem=cmake --builddir=build

override_dh_auto_test:
# Ignore test failures on problematic architectures only
ifeq (,$(filter $(DEB_BUILD_ARCH),amd64))
	PYTHONPATH=$(CURDIR)/build dh_auto_test || echo "Ignoring test failures"
else
	PYTHONPATH=$(CURDIR)/build dh_auto_test
endif

execute_after_dh_auto_install:
	find $(CURDIR)/debian/tmp -name '*.so*' -exec chrpath -d {} \;
