## jeolib-jiplib 1.1.7+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 ###############################################################################
 # CMakeLists build script for cmake
 # Author(s): Pieter.Kempeneers@ec.europa.eu
-# Copyright (C) 2016-2023 European Union (Joint Research Centre)
+# Copyright (C) 2016-2026 European Union (Joint Research Centre)
 #
 # This file is part of jiplib.
 
@@ -32,7 +32,7 @@
 
 SET(JIPLIB_VERSION_MAJOR 1)
 SET(JIPLIB_VERSION_MINOR 1)
-SET(JIPLIB_VERSION_PATCH 6)
+SET(JIPLIB_VERSION_PATCH 7)
 SET(JIPLIB_VERSION "${JIPLIB_VERSION_MAJOR}.${JIPLIB_VERSION_MINOR}.${JIPLIB_VERSION_PATCH}")
 SET(PACKAGE_VERSION "${JIPLIB_VERSION}")
 SET(JIPLIB_SOVERSION "${JIPLIB_VERSION_MAJOR}")
@@ -124,7 +124,7 @@
 
 # Make sure Boost libraries are found
 SET(Boost_DEBUG 0)
-find_package(Boost COMPONENTS filesystem system serialization REQUIRED)
+find_package(Boost COMPONENTS filesystem serialization REQUIRED)
 
 if(BUILD_WITH_PYTHON)
   # SET(CREATE_WHEEL TRUE CACHE BOOL "Choose if jiplib PYTHON wheel is to be created")
