=== debian/changelog ===
jeolib-jiplib (1.1.7+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    (closes: #1110635)
  * Drop Priority: optional, default since dpkg 1.22.13.
  * Bump Standards-Version to 4.7.3, changes: priority.
  * Mark libjiplib1 as Multi-Arch: same.
  * Drop patches applied upstream, refresh remaining patches.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 09 Feb 2026 13:45:52 +0100

jeolib-jiplib (1.1.6+ds-3) unstable; urgency=medium

  * Team upload.
  * Replace python3-all-dev build dependency with python3-dev.
    (closes: #1120566)
  * Fix Vcs-* URLs.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 03 Dec 2025 07:17:54 +0100
