=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Francesco Paolo Lovergine <frankie@debian.org>
 Section: libs
-Priority: optional
 Build-Depends: chrpath,
                cmake,
                debhelper-compat (= 13),
@@ -18,15 +17,15 @@
                libmiallib-dev,
                pkgconf,
                python3,
-               python3-all-dev,
+               python3-dev,
                python3-numpy,
                python3-numpy-dev,
                python3-pip,
                python3-setuptools,
                swig
-Standards-Version: 4.7.2
-Vcs-Browser: https://salsa.debian.org/debiani-gis/jeolib-jiplib
-Vcs-Git: https://salsa.debian.org/debian-gis/jeolib-jiplib.git
+Standards-Version: 4.7.3
+Vcs-Browser: https://salsa.debian.org/debian-gis-team/jeolib-jiplib
+Vcs-Git: https://salsa.debian.org/debian-gis-team/jeolib-jiplib.git
 Homepage: https://github.com/ec-jrc/jeolib-jiplib
 
 Package: libjiplib-dev
@@ -51,6 +50,7 @@
  program that uses this library.
 
 Package: libjiplib1
+Multi-Arch: same
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends}
